CHANGELOG for 6.1.x
===================

This changelog references the relevant changes (bug and security fixes) done
in 6.1 minor versions.

To get the diff for a specific change, go to https://github.com/symfony/symfony/commit/XXX where XXX is the change hash
To get the diff between two versions, go to https://github.com/symfony/symfony/compare/v6.1.0...v6.1.1

* 6.1.1 (2022-06-09)

 * bug #46570 [HttpClient][WebProfilerBundle] Catch errors when encoding body for c… (Phillip Look)
 * bug #46583 [HttpClient] Copy as curl fixes (HypeMC)
 * bug #46625 [FrameworkBundle] Disable Serializer data collect by default (chalasr)
 * bug #46545 Fix getting class constraints on debug command (loic425)
 * bug #46548 [Mime] Allow url as a path in the DataPart::fromPath (wkania)
 * bug #46576 Fix choice filter error when loading mix of grouped and non-grouped choices (BreyndotEchse)
 * bug #46594 [FrameworkBundle] Fix XML cache config (HeahDude)
 * bug #46610 [Messenger] use the outermost wrapping DBAL connection (xabbuh)
 * bug #46595 [Console] Escape  in command name & description from getDefaultName() (ogizanagi)
 * bug #46608 [Console] Fix deprecation when description is null (HypeMC)
 * bug #46586 [HttpKernel] Fix BackedEnumValueResolver already resolved enum value (janatjak)
 * bug #46574 [Console] Escape  in command name & description from PHP (getDefault* methods) (ogizanagi)
 * bug #46577 [Serializer] Fix ignore attribute in Xml files (alamirault)
 * bug #46565 [WebProfilerBundle] Fix dark theme selected line highlight color & reuse css vars (ogizanagi)
 * bug #46553 [WebProfilerBundle] normalizer and encoder can be undefined in template (kor3k)
 * bug #46538 [FrameworkBundle][HtmlSanitizer] Fix calling `allowStaticElements` when setting `allow_all_static_elements: true` (norkunas)
 * bug #46525 [Serializer] Get attributeContext after converting name (zenas1210)
 * bug #46535 [Mime] Check that the path is a file in the DataPart::fromPath (wkania)
 * bug #46543 [Cache] do not pass null to strlen() (xabbuh)
 * bug #46523 [HttpFoundation] Revert "Send `Content-Length` when calling `Response::send()` and the content is a non-empty string" (nicolas-grekas)
 * bug #46526 [Serializer] Added missing __call to TraceableEncoder (danielburger1337)
 * bug #46527 [Serializer] Forget partially collected traces (mtarld)
 * bug #46515 [PropertyInfo] Fix extracting int range type (norkunas)
 * bug #46511 [Serializer] Added missing __call to TraceableNormalizer and TraceableSerializer (danielburger1337)
 * bug #46478 [Contracts] remove static cache from `ServiceSubscriberTrait` (kbond)
 * bug #46480 [FrameworkBundle][TwigBundle] Fix registering html-sanitizer services (nicolas-grekas)
 * bug #46475 [MonologBridge] ensure that the $response property is initialized before being read (xabbuh)

* 6.1.0 (2022-05-27)

 * bug #46453 [PropertyInfo] Fix resolution of partially docblock covered constructors (ostrolucky)
 * bug #46454 [ExpressionLanguage] Fix null-safe chaining (HypeMC)
 * bug #46386 [Console]  Fix missing negative variation of negatable options in shell completion (GromNaN)
 * bug #46387 [Console] Complete negatable options (Fish) (GromNaN)
 * bug #46448 [DependencyInjection] Fix "proxy" tag: resolve its parameters and pass it to child definitions (nicolas-grekas)
 * bug #46442 [FrameworkBundle] Revert "bug #46125  Always add CacheCollectorPass (fancyweb)" (chalasr)
 * bug #46443 [DoctrineBridge] Don't reinit managers when they are proxied as ghost objects (nicolas-grekas)
 * bug #46427 [FrameworkBundle] fix wiring of annotations.cached_reader (nicolas-grekas)
 * bug #46425 [DependencyInjection] Ignore unused bindings defined by attribute (nicolas-grekas)
 * bug #46434 [FrameworkBundle] Fix BC break in abstract config commands (yceruto)
 * bug #46424 [Form] do not accept array input when a form is not multiple (xabbuh)
 * bug #46367 [Mime] Throw exception when body in Email attach method is not ok (alamirault)
 * bug #46421 [VarDumper][VarExporter] Deal with DatePeriod->include_end_date on PHP 8.2 (nicolas-grekas)
 * bug #46401 [Cache] Throw when "redis_sentinel" is used with a non-Predis "class" option (buffcode)
 * bug #46414 Bootstrap 4 fieldset for row errors (konradkozaczenko)
 * bug #46412 [FrameworkBundle] Fix dumping extension config without bundle (yceruto)
 * bug #46385 [HttpKernel] New bundle path convention when `AbstractBundle` is used (yceruto)
 * bug #46382 [HttpClient] Honor "max_duration" when replacing requests with async decorators (nicolas-grekas)
 * bug #46407 [Filesystem] Safeguard (sym)link calls (derrabus)
 * bug #46098 [Form] Fix same choice loader with different choice values (HeahDude)
 * bug #46380 [HttpClient] Add missing HttpOptions::setMaxDuration() (nicolas-grekas)
 * bug #46377 [HttpKernel] Fix missing null type in `ErrorListener::__construct()` (chalasr)
 * bug #46249 [HttpFoundation] [Session] Regenerate invalid session id (peter17)
 * bug #46373 [HtmlSanitizer] Fix default config service definition (wouterj)
 * bug #46328 [Config] Allow scalar configuration in PHP Configuration (jderusse, HypeMC)
 * bug #46366 [Mime] Add null check for EmailHeaderSame (magikid)
 * bug #46361 [PropertyInfo] Ignore empty doc-block for promoted properties in PhpStanExtractor (BoShurik)
 * bug #46364 [Config] Fix looking for single files in phars with GlobResource (nicolas-grekas)
 * bug #46365 [HttpKernel] Revert "bug #46327  Allow ErrorHandler ^5.0 to be used" (nicolas-grekas)

* 6.1.0-RC1 (2022-05-14)

 * feature #46335 [Form][FrameworkBundle][TwigBundle] Add Twig filter, form-type extension and improve service definitions for HtmlSanitizer (nicolas-grekas)
 * bug #46114 Fixes "Incorrectly nested style tag found" error when using multi-line header content (Perturbatio)
 * bug #46325 [Ldap] Fix LDAP connection options (buffcode)
 * bug #46341 Fix aliases handling in command name completion (Seldaek)
 * bug #46317 [Security/Http] Ignore invalid URLs found in failure/success paths (nicolas-grekas)
 * bug #46309 [Security] Fix division by zero (tvlooy)
 * bug #46327 [HttpKernel] Allow ErrorHandler ^5.0 to be used in HttpKernel 4.4 (mpdude)
 * bug #46310 [MonologBridge] Fix LevelName being removed in Monolog 3.0 (Seldaek)
 * bug #46297 [Serializer] Fix JsonSerializableNormalizer ignores circular reference handler in $context (BreyndotEchse)
 * bug #46291 [Console] Suppress unhandled error in some specific use-cases. (rw4lll)
 * bug #46302 [ErrorHandler] Fix list of tentative return types (nicolas-grekas)
 * bug #46293 [HttpClient] "debug" is missing if a request failed to even start (weaverryan)
 * bug #45981 [Serializer][PropertyInfo] Fix support for "false" built-in type on PHP 8.2 (alexandre-daubois)
 * feature #41676 [Console] Table vertical rendering (yoannrenard)
 * bug #46277 [HttpKernel] Fix SessionListener without session in request (edditor)
 * bug #46282 [DoctrineBridge] Treat firstResult === 0 like null (derrabus)
 * bug #46239 [Translation] Refresh local translations on PushCommand if the provider has domains (Florian-B)
 * bug #46274 [HtmlSanitizer] Fix node renderer handling of self-closing (void) elements (omniError)
 * bug #46276 [DependencyInjection] Fix lazyness of AutowiringFailedException (nicolas-grekas)
 * bug #46278 [Workflow] Fix deprecated syntax for interpolated strings (nicolas-grekas)
 * bug #46264 [Console] Better required argument check in InputArgument (jnoordsij)
 * bug #46272 [DependencyInjection] Fix resolving parameters found in #[Autowire] (nicolas-grekas)
 * bug #46262 [EventDispatcher] Fix removing listeners when using first-class callable syntax (javer)
 * feature #46153 [MonologBridge] Add support for Monolog 3 (Seldaek)
 * bug #46199 [HttpKernel] Handle previously converted `DateTime` arguments (mbabker)
 * bug #46216 [Form] fix populating single widget time view data with different timezones (xabbuh)
 * bug #46221 [DomCrawler][VarDumper] Fix html-encoding emojis (nicolas-grekas)
 * bug #46220 [Console] Fix fish completion script (wouterj)
 * bug #46167 [VarExporter] Fix exporting DateTime objects on PHP 8.2 (nicolas-grekas)

* 6.1.0-BETA2 (2022-04-27)

 * feature #45282 [Serializer] Support canners in object normalizer (rmikalkenas)
 * feature #46157 [Routing] Remove variadic constructor signature (wouterj)
 * bug #46154 [Mailer] Restore X-Transport after failure (zenas1210)
 * bug #46178 [DependencyInjection] Properly declare #[When] as allowed on functions (nicolas-grekas)
 * bug #46171 [VarDumper] Fix dumping floats on PHP8 (nicolas-grekas)
 * bug #46170 Fix dumping enums on PHP 8.2 (nicolas-grekas)
 * bug #46143 [Cache] Prevent fatal errors on php 8 when running concurrently with TagAwareAdapter v6.1 (sbelyshkin)
 * bug #45896 [Cache] Optimize caching of tags (sbelyshkin)
 * bug #46149 Modify processing of uploaded files to be compatible with PHP 8.1 (p-golovin)
 * feature #46112 [DependencyInjection] Rename `#[InnerService]` to `#[MapDecorated]` (chalasr)
 * bug #46125 [FrameworkBundle] Always add CacheCollectorPass (fancyweb)
 * feature #45989 [FrameworkBundle] deprecate not setting http_method_override (Tobion)
 * feature #46042 [Routing] Add params variable to condition expression (HypeMC)
 * feature #46115 [FrameworkBundle] Add support for route attributes in kernel controller methods (dunglas)
 * bug #46121 Fix "Notice: Undefined index: headers" in messenger with Oracle (rjd22)
 * feature #45834 [DependencyInjection] add AsDecorator class attribute and InnerService parameter attribute (Jean-Beru)
 * bug #46106 [String] Fix ansi escape sequences regex (fancyweb)
 * feature #46056 [PropertyInfo] Add support for promoted properties in PhpStanExtractor (simPod)
 * feature #46047 [Notifier] smsapi - send messages in test mode (Patryk Kozłowski)
 * bug #46097 [Routing] fix router base url when default uri has trailing slash (Tobion)
 * feature #46052 [TwigBundle] Deprecate option "autoescape", use "autoescape_service[_method]" instead (nicolas-grekas)
 * bug #46054 [SecurityBundle] Use config's secret in remember-me signatures (jderusse)
 * feature #45528 [Routing] Add Requirement, a collection of universal regular-expressions constants to use as route parameter requirements (fancyweb)
 * bug #46051 Don't replace symfony/security-guard (derrabus)

* 6.1.0-BETA1 (2022-04-15)

 * feature #44798 [FrameworkBundle] Integrate the HtmlSanitizer component (tgalopin, wouterj)
 * feature #46045 [Translation] Improve LocaleSwitcher a bit (nicolas-grekas)
 * feature #42403 [Validator] Define which collection keys should be checked for uniqueness (wkania)
 * feature #44405 [Routing] Allow using services in the route condition (renanbr)
 * feature #46009 [FrameworkBundle] Add support for first-class callable route controller in MicroKernelTrait (fancyweb)
 * feature #44155 [FrameworkBundle] Add semaphore configuration (jderusse)
 * feature #45803 [Routing] Add EnumRequirement to help generate route requirements from a \BackedEnum (fancyweb)
 * feature #45724 [FrameworkBundle] Add support to set BinaryFileResponse::trustXSendfileTypeHeader over config (alexander-schranz)
 * feature #45092 [HttpFoundation] Send `Content-Length` when calling `Response::send()` and the content is a non-empty string (nicolas-grekas)
 * feature #45967 [Messenger] Consume a PSR-14 dispatcher for dispatching events (derrabus)
 * feature #45951 [Notifier] [OvhCloud] Add `no_stop_clause` to DSN (alamirault)
 * feature #45795 [ExpressionLanguage] Add support for null-safe operator (mytuny)
 * feature #45605 [Form] Add prototype_options to CollectionType (michaelKaefer)
 * feature #45912 [ExpressionLanguage] Add some more operators (fabpot)
 * feature #45656 [Serializer] Add serializer profiler (mtarld)
 * feature #45072 [Validator] Allow creating constraints with required arguments (norkunas)
 * feature #43239 [Finder] Look for gitignore patterns up to git root (julienfalque)
 * feature #45845 [TwigBundle]  Pre-compile only *.twig files in cache warmup (GromNaN)
 * feature #44446 [Mailer] Improve extensibility of `EsmtpTransport` (ampaze)
 * feature #45226 [PhpUnitBridge] Add option `ignoreFile` to configure a file that lists deprecation messages to ignore (mondrake)
 * feature #43163 [Messenger] Add Redis Sentinel support (norbertschultheisz)
 * feature #43701 [HttpKernel] Simplifying Bundle/Extension config definition (yceruto)
 * feature #45873 [HttpFoundation] Allow dynamic session "ttl" when using a remote storage (nicolas-grekas)
 * feature #45878 [DependencyInjection] Add argument type `closure` to help passing closures to services (nicolas-grekas)
 * feature #44898 [Ldap] LDAP authentication should return a meaningful error when the LDAP server is unavailable (Jayfrown)
 * feature #45090 [Validator] Improve Image constraint invalid mime type message (fancyweb)
 * feature #42997 [Cache] Improve reliability and performance of `TagAwareAdapter` by making tag versions an integral part of item value (Sergey Belyshkin, nicolas-grekas)
 * feature #45512 [DependencyInjection] Allow using expressions as service factories (nicolas-grekas, jvasseur)
 * feature #45273 [Messenger] Allow AsMessageHandler attribute on methods (mjpvandenberg, fabpot)
 * feature #44284 [SecurityBundle] Display the inherited roles of the logged-in user in the WDT (jmsche)
 * feature #44303 Add Engagespot bridge (danut007ro)
 * feature #44532 Handle CSV DSN in ZookeeperStore (qkdreyer)
 * feature #45047 [Notifier] Use Importance level to set flash message type (benr77, fabpot)
 * feature #45166 [HttpFoundation] add stale while revalidate cache header (remieuronews)
 * feature #45195 [Notifier] Add Sendberry notifier bridge (StaffNowa)
 * feature #45793 [FrameworkBundle][Translation] add `LocaleSwitcher` service (kbond)
 * feature #45833 [HttpKernel] Add Http Status 423 LockedHttpException (xosofox)
 * feature #45705 [FrameworkBundle] Deprecate the messenger.reset_on_message config option (upyx)
 * feature #45812 [HttpClient] Improve default content-type handling (nicolas-grekas)
 * feature #45783 [DependencyInjection] adjust `Autowire` attribute implementation (kbond)
 * feature #44171 [Config] Add comment on array methods (jderusse)
 * feature #45657 [DependencyInjection] add `Autowire` parameter attribute (kbond)
 * feature #45725 [Finder] Fix SplFileInfo PHPDoc (InvisibleSmiley)
 * feature #44948 [Console] Add completion values to input definition (GromNaN)
 * feature #45745 [ErrorHandler][HttpKernel] Read SYMFONY_IDE to render exception in case of fatal error (GromNaN)
 * feature #45765 Mailer - Display email recipients in Profiler (raziel057)
 * feature #45094 Add generics to ArgumentMetadata::getAttributes (Seldaek)
 * feature #45761 Throw access denied if CurrentUser cannot be resolved instead of a 500 (Seldaek)
 * feature #45680 [DependencyInjection] use `#[Required]` for `ServiceSubscriberTrait::setContainer()` (kbond)
 * feature #45624 [Config] Allow using environment variables in `EnumNode` (ecourtial)
 * feature #45484 Make constraint violation interfaces stringable (HypeMC)
 * feature #43931 [HttpClient][WebProfilerBundle] Add button to copy a request as a cURL command (Deuchnord)
 * feature #45515 [BrowserKit] Add `toArray` to `Response` (HypeMC)
 * feature #45658 [Routing] Avoid double encoded slashes in query parameters (usu)
 * feature #45062 [PropertyInfo] Add PHP 8.0 promoted properties `@param` mutation support to PhpDocExtractor (raphaelvoisin)
 * feature #44522 [Messenger] add TransportMessageIdStamp to RedisSender (GaryPEGEOT)
 * feature #45623 [Validator] Deprecate constraint "ExpressionLanguageSyntax", use "ExpressionSyntax" instead (mpiot)
 * feature #45563 Deprecate requiring the "symfony/symfony" package (nicolas-grekas)
 * feature #45616 [HttpClient] Remove credentials from requests redirected to same host but different port (GromNaN)
 * feature #45377 Bump minimum version of PHP to 8.1 (nicolas-grekas)
 * feature #45421  [Translation] Add the possibilty to export xliff translation with the .xliff suffix (DanielBadura)
 * feature #45152 Ability to customize payload when sending mail through mailjet+api (gam6itko)
 * feature #44665 [HttpKernel] Add the UidValueResolver argument value resolver (fancyweb)
 * feature #44073 [ExpressionLanguage] Support lexing numbers with underscores and decimals with no leading zero (fancyweb)
 * feature #44721 [Serializer] Deprecate support for abstract uid denormalization in UidNormalizer (fancyweb)
 * feature #44615 [Routing] Support the "attribute" type (alias of "annotation") in annotation loaders (fancyweb)
 * feature #45265 [HttpKernel] Add Profiler::isEnabled() method (Bilge)
 * feature #45449 [Mime] Added getter for "TextPart::$name" (MasterRO94)
 * feature #45402 make Message classes extensible (bitgandtter)
 * feature #45476 [HttpKernel] Deprecate StreamedResponseListener, it serves no purpose anymore (nicolas-grekas)
 * feature #45436 [Messenger] Support setting `connection_name` for AMQP (a.dmitryuk)
 * feature #45450 [DependencyInjection] Add an env function to DI expression language (jvasseur)
 * feature #45388 [Mailer] Allow manually start() of SmtpTransport (jannick-holm)
 * feature #45376 [Mime] Fix embed logic for background attributes (flack)
 * feature #45360 [ErrorHandler] trigger deprecations for ``@final`` properties (nicolas-grekas, fancyweb)
 * feature #45371 [Validator] Deprecate `Constraint::$errorNames` in favor of `Constraint::ERROR_NAMES` (nicolas-grekas)
 * feature #44692 [Cache][FrameworkBundle] add `cache:pool:invalidate-tags` command (kbond)
 * feature #45361 [Console] Deprecate the `$defaultName` property (derrabus)
 * feature #45313 [Cache] Add support for ACL auth in RedisAdapter (gam6itko)
 * feature #45303 [ErrorHandler] Report overridden @final constants (fancyweb)
 * feature #44484 [Translation] [Loco] Send `If-Modified-Since` header when possible (Kocal)
 * feature #45307 [Mailer] Allow manually stop() of SmtpTransport (dvaeversted)
 * feature #43973 [Serializer] Add context builders (mtarld)
 * feature #45222 [Mailer] Implement EmailTags for Amazon Mailer (driesvints, kbond)
 * feature #44670 [SecurityBundle] Allow to specify a RequestMatcher directly in an ACL definition (TristanPouliquen)
 * feature #45139 [Notifier] smsapi-notifier `fast` option to sending message with the highest priority (marphi)
 * feature #45155 [Serializer] Set context annotation as not final (benjaminmal)
 * feature #44503 [FrameworkBundle] Allow PHP configuration in config/packages by default (dreadnip)
 * feature #45101 [Form] Add inputmode attribute on NumberType (welcoMattic)
 * feature #45075 [Routing] Enrich MissingMandatoryParametersException (adrienlucas)
 * feature #45064 [Messenger] Add sessionToken option to SQS transport (filkaris)
 * feature #44917 [Mailer] Add downloadable attachments to profiler (dbrekelmans)
 * feature #45054 [Routing] Allow using UTF-8 parameter names (nicolas-grekas)
 * feature #44360 [Notifier] [Bridge] [KazInfoTeh] added the bridge (taranovegor)
 * feature #44874 [Notifier] Added 46elks notifier bridge (jongotlin)
 * feature #44913 [Notifier] Add Orange SMS bridge (enigma972)
 * feature #44971 [Messenger] Resolve handled classes when only method in tag is provided (angelov)
 * feature #43982 [Messenger][Serializer] Deprecate "context aware" interfaces (mtarld)
 * feature #44790 [Serializer] Give more hints when an attribute is not correctly used (lyrixx)
 * feature #44831 [HttpKernel] Add a controller argument resolver for backed enums (ogizanagi)
 * feature #44589 [Messenger] add SerializedMessageStamp (nikophil)
 * feature #41750 [Yaml] Double-quote strings with single quote marks (Ostrzyciel)
 * feature #44774 Add `exclude` to `TaggedIterator` and `TaggedLocator` (ruudk)
 * feature #44681 [HtmlSanitizer] Introduce HtmlSanitizer component (tgalopin)
 * feature #44311 [Mime] add DraftEmail (kbond)
 * feature #44746 [Console] Add method `__toString()` to `InputInterface` (boesing)
 * feature #44568 [HttpClient] Allow yielding Exception from MockResponse's  $body to mock transport errors (fancyweb)
 * feature #44672 [Translation] Translatable parameters (sylfabre)
 * feature #44451 [PropertyInfo] Add support for phpDocumentor and PHPStan pseudo-types (EmilMassey)
 * feature #44575 [Framework] Read env var SYMFONY_IDE by default for framework.ide (GromNaN)
 * feature #43641 [Console] Issue 43602 : Add fish completion (guillaume-a)
 * feature #44150 [Assets] Accept empty `base_url`, in order to simplify local dev configuration. (GromNaN)
 * feature #44137 [Mailer] [Mailgun] Allow multiple TagHeaders with MailgunApiTransport (starred-gijs)
 * feature #44543 [HttpFoundation] Update cookie date time format (chapterjason)
 * feature #44483 [HttpKernel][WebProfilerBundle] adding xdebug_info page to webprofilerbundle (chr-hertel)

